##############################################################
# Conduct simulation
# linear regression w/ clusters
##############################################################

# varying-size clusters

#setwd("J:/Justin Esarey/Desktop/Complete Replication File/2015-5-7_linear_vary_simulation_results")
setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-7_linear_vary_simulation_results")
rm(list=ls())
source(file="clusterIM.glm.R", echo=F)
source(file="clusterwild.glm.R", echo=F)
source(file="clusterBS.glm.R", echo=F)
source(file="2015-5-7_cluster_linear.R", echo=F)
set.seed(387218)
clu.siz <- c(20,40,60)

clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 1), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 2), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 5), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 7), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 10), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 20), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 25), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 30), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 40), g.sd = 1, reps=1000)

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

vn.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
cl.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
mx.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
wd.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.v <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.c <- matrix(data=NA, nrow=length(cl.n), ncol=3)
re.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)

im.nonconverge <- c()
re.nonconverge <- c()

for(i in 1:length(cl.n)){
  load(paste("linear-vary-clusters-", cl.n[i],"_unique-3_sd-1.RData", sep=""))  
  
  vn.result[i,] <- colSums(list.out[[3]] < 0.05) / 1000
  cl.result[i,] <- colSums(list.out[[4]] < 0.05) / 1000
  mx.result[i,] <- colSums(list.out[[5]] < 0.05) / 1000
  im.result[i,] <- colSums(list.out[[6]] < 0.05, na.rm = T) / colSums(is.na(list.out[[6]])==F)
  wd.result[i,] <- colSums(list.out[[7]] < 0.05) / 1000
  bs.result.v[i,] <- colSums(list.out[[8]] < 0.05) / 1000
  bs.result.c[i,] <- colSums(list.out[[9]] < 0.05) / 1000
  re.result[i,] <- colSums(list.out[[10]] < 0.05, na.rm = T) / colSums(is.na(list.out[[10]])==F)
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[6]]))[1] / 1000
  re.nonconverge[i] <- colSums(is.na(list.out[[10]]))[1] / 1000
    
}

im.nonconverge
# 0 0 0 0 0 0 0 0 0
re.nonconverge
# 0.000 0.000 0.000 0.001 0.000 0.000 0.000 0.000 0.000


plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 0.6), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression False Positive Rates (varying cluster size)", "Cluster-Correlated Independent Variable"))

lines(bs.result.v[,1] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,1] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,1] ~ cl.n, lty=2)
lines(im.result[,1] ~ cl.n, lty=4, lwd=2)
lines(wd.result[,1] ~ cl.n, lty=3, lwd=2)
lines(re.result[,1] ~ cl.n, lwd=2)

legend("right", lty=c(1,2,4,3,1,2,1), lwd=c(1,1,2,2,3,3,2), col=c(rep("black",4), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "WCBSTs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates", "Random Effects"))


dev.copy2pdf(file="linear-cluster-vary-corr.pdf")



plot(bs.result.v[,2] ~ cl.n, lty=1, lwd=3, col="darkgray", type = "l", ylim = c(0, 0.25), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression False Positive Rates (varying cluster size)", "Cluster-Uncorrelated Independent Variable"))

lines(bs.result.c[,2] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(vn.result[,2] ~ cl.n)
lines(cl.result[,2] ~ cl.n, lty=2)
lines(im.result[,2] ~ cl.n, lty=4, lwd=2)
lines(wd.result[,2] ~ cl.n, lty=3, lwd=2)
lines(re.result[,2] ~ cl.n, lwd=2)

legend("topright", lty=c(1,2,4,3,1,2,1), lwd=c(1,1,2,2,3,3,2), col=c(rep("black",4), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "WCBSTs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates", "Random Effects"))

dev.copy2pdf(file="linear-cluster-vary-uncorr.pdf")







plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 0.6), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression False Positive Rates (varying cluster size)", "Cluster-Correlated Independent Variable"))

lines(cl.result[,1] ~ cl.n, lty=2)
lines(mx.result[,1] ~ cl.n, lty=4, lwd=2)

legend("right", lty=c(1,2,4), lwd=c(1,1,2), legend=c("vanilla SEs", "CRSEs", "maximum SE"))


dev.copy2pdf(file="linear-vary-max-corr.pdf")



plot(vn.result[,2] ~ cl.n, type = "l", ylim = c(0, 0.25), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression False Positive Rates (varying cluster size)", "Cluster-Uncorrelated Independent Variable"))

lines(cl.result[,2] ~ cl.n, lty=2)
lines(mx.result[,2] ~ cl.n, lty=4, lwd=2)

legend("right", lty=c(1,2,4), lwd=c(1,1,2), legend=c("vanilla SEs", "CRSEs", "maximum SE"))

dev.copy2pdf(file="linear-vary-max-uncorr.pdf")



##############################################################


# power test, varying-size clusters



#setwd("J:/Justin Esarey/Desktop/Complete Replication File/2015-5-7_linear_vary_simulation_results")
setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-7_linear_vary_simulation_results")
rm(list=ls())
source(file="clusterIM.glm.R", echo=F)
source(file="clusterwild.glm.R", echo=F)
source(file="clusterBS.glm.R", echo=F)
source(file="2015-5-7_cluster_linear_power.R", echo=F)
clu.siz <- c(20,40,60)

set.seed(387218)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 1), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 2), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 5), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 7), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 10), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 20), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 25), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 30), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(clu.siz, 40), g.sd = 1, reps=1000)

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

vn.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
cl.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
mx.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
wd.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.v <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.c <- matrix(data=NA, nrow=length(cl.n), ncol=3)
re.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)


im.nonconverge <- c()
re.nonconverge <- c()

for(i in 1:length(cl.n)){
  load(paste("power-linear-vary-clusters-", cl.n[i],"_unique-3_sd-1.RData", sep=""))
  vn.result[i,] <- colSums(list.out[[3]] < 0.05) / 1000
  cl.result[i,] <- colSums(list.out[[4]] < 0.05) / 1000
  mx.result[i,] <- colSums(list.out[[5]] < 0.05) / 1000
  im.result[i,] <- colSums(list.out[[6]] < 0.05, na.rm = T) / colSums(is.na(list.out[[6]])==F)
  wd.result[i,] <- colSums(list.out[[7]] < 0.05) / 1000
  bs.result.v[i,] <- colSums(list.out[[8]] < 0.05) / 1000
  bs.result.c[i,] <- colSums(list.out[[9]] < 0.05) / 1000
  re.result[i,] <- colSums(list.out[[10]] < 0.05, na.rm = T) / colSums(is.na(list.out[[10]])==F)
  
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[6]]))[1] / 1000
  re.nonconverge[i] <- colSums(is.na(list.out[[10]]))[1] / 1000
  
}

im.nonconverge
# 0 0 0 0 0 0 0 0 0
re.nonconverge
# 0.000 0.000 0.000 0.000 0.000 0.000 0.000 0.001 0.000



plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression True Positive Rates (varying cluster size)", "Cluster-Correlated Independent Variable"))

lines(bs.result.v[,1] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,1] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,1] ~ cl.n, lty=2)
lines(im.result[,1] ~ cl.n, lty=4, lwd=2)
lines(wd.result[,1] ~ cl.n, lty=3, lwd=2)
lines(re.result[,1] ~ cl.n, lwd=2)

legend("right", lty=c(1,2,4,3,1,2,1), lwd=c(1,1,2,2,3,3,2), col=c(rep("black",4), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "WCBSTs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates", "Random Effects"))

dev.copy2pdf(file="linear-power-vary-corr.pdf")



plot(bs.result.c[,2] ~ cl.n, lty=2, lwd=3, col="darkgray", type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression True Positive Rates (varying cluster size)", "Cluster-Uncorrelated Independent Variable"))

lines(bs.result.v[,2] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(vn.result[,2] ~ cl.n)
lines(cl.result[,2] ~ cl.n, lty=2)
lines(im.result[,2] ~ cl.n, lty=4, lwd=2)
lines(wd.result[,2] ~ cl.n, lty=3, lwd=2)
lines(re.result[,2] ~ cl.n, lwd=2)


legend("right", lty=c(1,2,4,3,1,2,1), lwd=c(1,1,2,2,3,3,2), col=c(rep("black",4), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "WCBSTs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates", "Random Effects"))

dev.copy2pdf(file="linear-power-vary-uncorr.pdf")
