##############################################################
# Conduct simulation
# probit w/ clusters
##############################################################

# same-size clusters

#setwd("J:/jesarey/Desktop/2015-5-6_binary_truncated_results")
setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
rm(list=ls())
source(file="clusterIM.glm.R", echo=F)
source(file="clusterwild.glm.R", echo=F)
source(file="clusterBS.glm.R", echo=F)
source(file="2015-5-15_cluster_binary.R", echo=F)
set.seed(387218)
clusterIMtestProbit(obs.per.cluster = rep(40, 3), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 6), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 15), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 21), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 30), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 60), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 75), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 90), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 120), g.sd = 1, reps=1000)

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

vn.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
cl.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
mx.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.v <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.c <- matrix(data=NA, nrow=length(cl.n), ncol=3)

im.nonconverge <- c()

for(i in 1:length(cl.n)){
  load(paste("binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  
  vn.result[i,] <- colSums(list.out[[1]] < 0.05) / 1000
  cl.result[i,] <- colSums(list.out[[2]] < 0.05) / 1000
  mx.result[i,] <- colSums(list.out[[3]] < 0.05) / 1000
  im.result[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  bs.result.v[i,] <- colSums(list.out[[5]] < 0.05) / 1000
  bs.result.c[i,] <- colSums(list.out[[6]] < 0.05) / 1000
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
    
}

im.nonconverge
# 0.001 0.000 0.000 0.000 0.000 0.000 0.000 0.000 0.000

# proportion of non-converged results
plot(im.nonconverge ~ cl.n, type = "l", ylim=c(0, 1), xlab = "number of clusters", ylab = "prop. of missing CAT results", main = c("Probit GLM w/ CATs", "non-converged false positive models"))

dev.copy2pdf(file="probit-converge.pdf")


plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 0.5), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit False Positive Rates (cluster size = 40)", "Cluster-Correlated Independent Variable"))

lines(bs.result.v[,1] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,1] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,1] ~ cl.n, lty=2)
lines(im.result[,1] ~ cl.n, lty=4, lwd=2)

legend("right", lty=c(1,2,4,1,2), lwd=c(1,1,2,3,3), col=c(rep("black",3), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates"))


dev.copy2pdf(file="binary-cluster-corr.pdf")



plot(vn.result[,2] ~ cl.n, type = "l", ylim = c(0, 0.5), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit False Positive Rates (cluster size = 40)", "Cluster-Uncorrelated Independent Variable"))

lines(bs.result.v[,2] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,2] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,2] ~ cl.n, lty=2)
lines(im.result[,2] ~ cl.n, lty=4, lwd=2)


legend("right", lty=c(1,2,4,1,2), lwd=c(1,1,2,3,3), col=c(rep("black",3), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates"))

dev.copy2pdf(file="binary-cluster-uncorr.pdf")


##############################################################


# power test, same-size clusters


#setwd("J:/jesarey/Desktop/2015-5-6_binary_truncated_results")
setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
rm(list=ls())
source(file="clusterIM.glm.R", echo=F)
source(file="clusterwild.glm.R", echo=F)
source(file="clusterBS.glm.R", echo=F)
source(file="2015-5-15_cluster_binary_power.R", echo=F)

set.seed(387218)
clusterIMtestProbit(obs.per.cluster = rep(40, 3), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 6), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 15), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 21), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 30), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 60), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 75), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 90), g.sd = 1, reps=1000)
clusterIMtestProbit(obs.per.cluster = rep(40, 120), g.sd = 1, reps=1000)

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

vn.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
cl.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
mx.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.v <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.c <- matrix(data=NA, nrow=length(cl.n), ncol=3)


im.nonconverge <- c()

for(i in 1:length(cl.n)){
  load(paste("power-binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))
  vn.result[i,] <- colSums(list.out[[1]] < 0.05) / 1000
  cl.result[i,] <- colSums(list.out[[2]] < 0.05) / 1000
  mx.result[i,] <- colSums(list.out[[3]] < 0.05) / 1000
  im.result[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  bs.result.v[i,] <- colSums(list.out[[5]] < 0.05) / 1000
  bs.result.c[i,] <- colSums(list.out[[6]] < 0.05) / 1000
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
  
}

im.nonconverge
# 0.009 0.001 0.000 0.000 0.000 0.000 0.000 0.000 0.000

# proportion of non-converged results
plot(im.nonconverge ~ cl.n, type = "l", ylim=c(0, 1), xlab = "number of clusters", ylab = "prop. of missing CAT results", main = c("Probit GLM w/ CATs", "non-converged true positive models"))

dev.copy2pdf(file="probit-converge-power.pdf")



plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit True Positive Rates (cluster size = 40)", "Cluster-Correlated Independent Variable"))

lines(bs.result.v[,1] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,1] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,1] ~ cl.n, lty=2)
lines(im.result[,1] ~ cl.n, lty=4, lwd=2)

legend("right", lty=c(1,2,4,1,2), lwd=c(1,1,2,3,3), col=c(rep("black",3), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates"))

dev.copy2pdf(file="binary-power-corr.pdf")



plot(bs.result.v[,2] ~ cl.n, lty=1, lwd=3, col="darkgray", type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit True Positive Rates (cluster size = 40)", "Cluster-Uncorrelated Independent Variable"))

lines(bs.result.c[,2] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(vn.result[,2] ~ cl.n, lty=1, lwd=1)
lines(cl.result[,2] ~ cl.n, lty=2)
lines(im.result[,2] ~ cl.n, lty=4, lwd=2)

legend("right", lty=c(1,2,4,1,2), lwd=c(1,1,2,3,3), col=c(rep("black",3), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates"))

dev.copy2pdf(file="binary-power-uncorr.pdf")







####################################################
# compare dropped clusters to no dropped clusters

setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
rm(list=ls())

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

im.result.d <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result.t <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)

im.nonconverge <- c()
im.nonconverge.d <- c()
im.nonconverge.t <- c()

for(i in 1:length(cl.n)){
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
  load(paste("binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result.t[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  
  # proportion of non-converged results
  im.nonconverge.t[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-6_binary_dropped_results")
  load(paste("binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result.d[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)

  # proportion of non-converged results
  im.nonconverge.d[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-5_binary_simulation_results")
  load(paste("binary-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[4]]))[1] / 1000

}

setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")

im.nonconverge.t
# 0.001 0.000 0.000 0.000 0.000 0.000 0.000 0.000 0.000
im.nonconverge.d
# 0.001 0.000 0.000 0.000 0.000 0.000 0.000 0.000 0.000
im.nonconverge
# 0.097 0.181 0.419 0.512 0.653 0.840 0.917 0.948 0.981

plot(im.result[,1] ~ cl.n, type = "l", lty=4, lwd=2, ylim = c(0, 0.15), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit False Positive Rates (cluster size = 40)", "Cluster-Correlated Independent Variable"))
lines(im.result.d[,1] ~ cl.n, lty=4, lwd=4, col="darkgray")
lines(im.result.t[,1] ~ cl.n, lty=1, lwd=1)

legend("topright", lty=c(4, 4, 1), lwd=c(2, 4, 1), col=c("black", "darkgray", "black"), legend=c("CATs", "CATs, drop failed clusters", "CATs, drop failed and outlying clusters"))


dev.copy2pdf(file="binary-cluster-drop-vs-not.pdf")



plot(im.result[,2] ~ cl.n, lty=4, lwd=2, type = "l", ylim = c(0, 0.15), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit False Positive Rates (cluster size = 40)", "Cluster-Uncorrelated Independent Variable"))
lines(im.result.d[,2] ~ cl.n, lty=4, lwd=4, col="darkgray")
lines(im.result.t[,2] ~ cl.n, lty=1, lwd=1)

legend("topright", lty=c(4, 4, 1), lwd=c(2, 4, 1), col=c("black", "darkgray", "black"), legend=c("CATs", "CATs, drop failed clusters", "CATs, drop failed and outlying clusters"))

dev.copy2pdf(file="binary-cluster-uncorr-drop-vs-not.pdf")











# now power

setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
rm(list=ls())

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

im.result.d <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result.t <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)

im.nonconverge <- c()
im.nonconverge.d <- c()
im.nonconverge.t <- c()

for(i in 1:length(cl.n)){
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")
  load(paste("power-binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result.t[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  
  # proportion of non-converged results
  im.nonconverge.t[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-6_binary_dropped_results")
  load(paste("power-binary-drop-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result.d[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  
  # proportion of non-converged results
  im.nonconverge.d[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
  setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-5-5_binary_simulation_results")
  load(paste("power-binary-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))  
  im.result[i,] <- colSums(list.out[[4]] < 0.05, na.rm = T) / colSums(is.na(list.out[[4]])==F)
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[4]]))[1] / 1000
  
}

setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-7-19_binary_truncated_results")

im.nonconverge.t
# 0.009 0.001 0.000 0.000 0.000 0.000 0.000 0.000 0.000
im.nonconverge.d
# 0.009 0.000 0.000 0.000 0.000 0.000 0.000 0.000 0.000
im.nonconverge
# 0.176 0.319 0.661 0.747 0.860 0.986 0.992 0.998 1.000

plot(im.result[,1] ~ cl.n, type = "l", lty=4, lwd=2, ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit False Positive Rates (cluster size = 40)", "Cluster-Correlated Independent Variable"))
lines(im.result.d[,1] ~ cl.n, lty=4, lwd=4, col="darkgray")
lines(im.result.t[,1] ~ cl.n, lty=1, lwd=1)

legend("bottomright", lty=c(4, 4, 1), lwd=c(2, 4, 1), col=c("black", "darkgray", "black"), legend=c("CATs", "CATs, drop failed clusters", "CATs, drop failed and outlying clusters"))


dev.copy2pdf(file="binary-power-cluster-drop-vs-not.pdf")



plot(im.result.t[,2] ~ cl.n, lty=1, lwd=1, col="black", type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Probit True Positive Rates (cluster size = 40)", "Cluster-Uncorrelated Independent Variable"))
lines(im.result.d[,2] ~ cl.n, lty=4, lwd=4, col="darkgray")
lines(im.result[,2] ~ cl.n, lty=4, lwd=2)

legend("bottomright", lty=c(4, 4, 1), lwd=c(2, 4, 1), col=c("black", "darkgray", "black"), legend=c("CATs", "CATs, drop failed clusters", "CATs, drop failed and outlying clusters"))

dev.copy2pdf(file="binary-power-cluster-uncorr-drop-vs-not.pdf")




im.result.t
# [,1]      [,2]      [,3]
# [1,] 0.09989909 0.1069627 0.4480323
# [2,] 0.32932933 0.3213213 0.9399399
# [3,] 0.76200000 0.8010000 1.0000000
# [4,] 0.90000000 0.8780000 1.0000000
# [5,] 0.96500000 0.9540000 1.0000000
# [6,] 1.00000000 1.0000000 1.0000000
# [7,] 0.99900000 1.0000000 1.0000000
# [8,] 1.00000000 1.0000000 1.0000000
# [9,] 1.00000000 1.0000000 1.0000000
